// Code generated by SQLBoiler 4.14.2 (https://github.com/volatiletech/sqlboiler). DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package models

import (
	"context"
	"database/sql"
	"fmt"
	"reflect"
	"strconv"
	"strings"
	"sync"
	"time"

	"github.com/friendsofgo/errors"
	"github.com/volatiletech/null/v8"
	"github.com/volatiletech/sqlboiler/v4/boil"
	"github.com/volatiletech/sqlboiler/v4/queries"
	"github.com/volatiletech/sqlboiler/v4/queries/qm"
	"github.com/volatiletech/sqlboiler/v4/queries/qmhelper"
	"github.com/volatiletech/strmangle"
)

// ProductGold is an object representing the database table.
type ProductGold struct {
	ID             int64        `boil:"id" json:"id" toml:"id" yaml:"id"`
	IDGoal         null.Int64   `boil:"id_goal" json:"id_goal,omitempty" toml:"id_goal" yaml:"id_goal,omitempty"`
	WeightGoal     null.Float64 `boil:"weight_goal" json:"weight_goal,omitempty" toml:"weight_goal" yaml:"weight_goal,omitempty"`
	CategoryGoalID null.Int64   `boil:"category_goal_id" json:"category_goal_id,omitempty" toml:"category_goal_id" yaml:"category_goal_id,omitempty"`
	CreatedAt      time.Time    `boil:"created_at" json:"created_at" toml:"created_at" yaml:"created_at"`
	UpdatedAt      time.Time    `boil:"updated_at" json:"updated_at" toml:"updated_at" yaml:"updated_at"`

	R *productGoldR `boil:"-" json:"-" toml:"-" yaml:"-"`
	L productGoldL  `boil:"-" json:"-" toml:"-" yaml:"-"`
}

var ProductGoldColumns = struct {
	ID             string
	IDGoal         string
	WeightGoal     string
	CategoryGoalID string
	CreatedAt      string
	UpdatedAt      string
}{
	ID:             "id",
	IDGoal:         "id_goal",
	WeightGoal:     "weight_goal",
	CategoryGoalID: "category_goal_id",
	CreatedAt:      "created_at",
	UpdatedAt:      "updated_at",
}

var ProductGoldTableColumns = struct {
	ID             string
	IDGoal         string
	WeightGoal     string
	CategoryGoalID string
	CreatedAt      string
	UpdatedAt      string
}{
	ID:             "product_gold.id",
	IDGoal:         "product_gold.id_goal",
	WeightGoal:     "product_gold.weight_goal",
	CategoryGoalID: "product_gold.category_goal_id",
	CreatedAt:      "product_gold.created_at",
	UpdatedAt:      "product_gold.updated_at",
}

// Generated where

var ProductGoldWhere = struct {
	ID             whereHelperint64
	IDGoal         whereHelpernull_Int64
	WeightGoal     whereHelpernull_Float64
	CategoryGoalID whereHelpernull_Int64
	CreatedAt      whereHelpertime_Time
	UpdatedAt      whereHelpertime_Time
}{
	ID:             whereHelperint64{field: "\"product_gold\".\"id\""},
	IDGoal:         whereHelpernull_Int64{field: "\"product_gold\".\"id_goal\""},
	WeightGoal:     whereHelpernull_Float64{field: "\"product_gold\".\"weight_goal\""},
	CategoryGoalID: whereHelpernull_Int64{field: "\"product_gold\".\"category_goal_id\""},
	CreatedAt:      whereHelpertime_Time{field: "\"product_gold\".\"created_at\""},
	UpdatedAt:      whereHelpertime_Time{field: "\"product_gold\".\"updated_at\""},
}

// ProductGoldRels is where relationship names are stored.
var ProductGoldRels = struct {
	CategoryGoal                    string
	IDGoalOrderGoal                 string
	DetailProductDetailProductGolds string
}{
	CategoryGoal:                    "CategoryGoal",
	IDGoalOrderGoal:                 "IDGoalOrderGoal",
	DetailProductDetailProductGolds: "DetailProductDetailProductGolds",
}

// productGoldR is where relationships are stored.
type productGoldR struct {
	CategoryGoal                    *CategoryGoal          `boil:"CategoryGoal" json:"CategoryGoal" toml:"CategoryGoal" yaml:"CategoryGoal"`
	IDGoalOrderGoal                 *OrderGoal             `boil:"IDGoalOrderGoal" json:"IDGoalOrderGoal" toml:"IDGoalOrderGoal" yaml:"IDGoalOrderGoal"`
	DetailProductDetailProductGolds DetailProductGoldSlice `boil:"DetailProductDetailProductGolds" json:"DetailProductDetailProductGolds" toml:"DetailProductDetailProductGolds" yaml:"DetailProductDetailProductGolds"`
}

// NewStruct creates a new relationship struct
func (*productGoldR) NewStruct() *productGoldR {
	return &productGoldR{}
}

func (r *productGoldR) GetCategoryGoal() *CategoryGoal {
	if r == nil {
		return nil
	}
	return r.CategoryGoal
}

func (r *productGoldR) GetIDGoalOrderGoal() *OrderGoal {
	if r == nil {
		return nil
	}
	return r.IDGoalOrderGoal
}

func (r *productGoldR) GetDetailProductDetailProductGolds() DetailProductGoldSlice {
	if r == nil {
		return nil
	}
	return r.DetailProductDetailProductGolds
}

// productGoldL is where Load methods for each relationship are stored.
type productGoldL struct{}

var (
	productGoldAllColumns            = []string{"id", "id_goal", "weight_goal", "category_goal_id", "created_at", "updated_at"}
	productGoldColumnsWithoutDefault = []string{}
	productGoldColumnsWithDefault    = []string{"id", "id_goal", "weight_goal", "category_goal_id", "created_at", "updated_at"}
	productGoldPrimaryKeyColumns     = []string{"id"}
	productGoldGeneratedColumns      = []string{}
)

type (
	// ProductGoldSlice is an alias for a slice of pointers to ProductGold.
	// This should almost always be used instead of []ProductGold.
	ProductGoldSlice []*ProductGold
	// ProductGoldHook is the signature for custom ProductGold hook methods
	ProductGoldHook func(context.Context, boil.ContextExecutor, *ProductGold) error

	productGoldQuery struct {
		*queries.Query
	}
)

// Cache for insert, update and upsert
var (
	productGoldType                 = reflect.TypeOf(&ProductGold{})
	productGoldMapping              = queries.MakeStructMapping(productGoldType)
	productGoldPrimaryKeyMapping, _ = queries.BindMapping(productGoldType, productGoldMapping, productGoldPrimaryKeyColumns)
	productGoldInsertCacheMut       sync.RWMutex
	productGoldInsertCache          = make(map[string]insertCache)
	productGoldUpdateCacheMut       sync.RWMutex
	productGoldUpdateCache          = make(map[string]updateCache)
	productGoldUpsertCacheMut       sync.RWMutex
	productGoldUpsertCache          = make(map[string]insertCache)
)

var (
	// Force time package dependency for automated UpdatedAt/CreatedAt.
	_ = time.Second
	// Force qmhelper dependency for where clause generation (which doesn't
	// always happen)
	_ = qmhelper.Where
)

var productGoldAfterSelectHooks []ProductGoldHook

var productGoldBeforeInsertHooks []ProductGoldHook
var productGoldAfterInsertHooks []ProductGoldHook

var productGoldBeforeUpdateHooks []ProductGoldHook
var productGoldAfterUpdateHooks []ProductGoldHook

var productGoldBeforeDeleteHooks []ProductGoldHook
var productGoldAfterDeleteHooks []ProductGoldHook

var productGoldBeforeUpsertHooks []ProductGoldHook
var productGoldAfterUpsertHooks []ProductGoldHook

// doAfterSelectHooks executes all "after Select" hooks.
func (o *ProductGold) doAfterSelectHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range productGoldAfterSelectHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeInsertHooks executes all "before insert" hooks.
func (o *ProductGold) doBeforeInsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range productGoldBeforeInsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterInsertHooks executes all "after Insert" hooks.
func (o *ProductGold) doAfterInsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range productGoldAfterInsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeUpdateHooks executes all "before Update" hooks.
func (o *ProductGold) doBeforeUpdateHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range productGoldBeforeUpdateHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterUpdateHooks executes all "after Update" hooks.
func (o *ProductGold) doAfterUpdateHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range productGoldAfterUpdateHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeDeleteHooks executes all "before Delete" hooks.
func (o *ProductGold) doBeforeDeleteHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range productGoldBeforeDeleteHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterDeleteHooks executes all "after Delete" hooks.
func (o *ProductGold) doAfterDeleteHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range productGoldAfterDeleteHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeUpsertHooks executes all "before Upsert" hooks.
func (o *ProductGold) doBeforeUpsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range productGoldBeforeUpsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterUpsertHooks executes all "after Upsert" hooks.
func (o *ProductGold) doAfterUpsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range productGoldAfterUpsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// AddProductGoldHook registers your hook function for all future operations.
func AddProductGoldHook(hookPoint boil.HookPoint, productGoldHook ProductGoldHook) {
	switch hookPoint {
	case boil.AfterSelectHook:
		productGoldAfterSelectHooks = append(productGoldAfterSelectHooks, productGoldHook)
	case boil.BeforeInsertHook:
		productGoldBeforeInsertHooks = append(productGoldBeforeInsertHooks, productGoldHook)
	case boil.AfterInsertHook:
		productGoldAfterInsertHooks = append(productGoldAfterInsertHooks, productGoldHook)
	case boil.BeforeUpdateHook:
		productGoldBeforeUpdateHooks = append(productGoldBeforeUpdateHooks, productGoldHook)
	case boil.AfterUpdateHook:
		productGoldAfterUpdateHooks = append(productGoldAfterUpdateHooks, productGoldHook)
	case boil.BeforeDeleteHook:
		productGoldBeforeDeleteHooks = append(productGoldBeforeDeleteHooks, productGoldHook)
	case boil.AfterDeleteHook:
		productGoldAfterDeleteHooks = append(productGoldAfterDeleteHooks, productGoldHook)
	case boil.BeforeUpsertHook:
		productGoldBeforeUpsertHooks = append(productGoldBeforeUpsertHooks, productGoldHook)
	case boil.AfterUpsertHook:
		productGoldAfterUpsertHooks = append(productGoldAfterUpsertHooks, productGoldHook)
	}
}

// One returns a single productGold record from the query.
func (q productGoldQuery) One(ctx context.Context, exec boil.ContextExecutor) (*ProductGold, error) {
	o := &ProductGold{}

	queries.SetLimit(q.Query, 1)

	err := q.Bind(ctx, exec, o)
	if err != nil {
		if errors.Is(err, sql.ErrNoRows) {
			return nil, sql.ErrNoRows
		}
		return nil, errors.Wrap(err, "models: failed to execute a one query for product_gold")
	}

	if err := o.doAfterSelectHooks(ctx, exec); err != nil {
		return o, err
	}

	return o, nil
}

// All returns all ProductGold records from the query.
func (q productGoldQuery) All(ctx context.Context, exec boil.ContextExecutor) (ProductGoldSlice, error) {
	var o []*ProductGold

	err := q.Bind(ctx, exec, &o)
	if err != nil {
		return nil, errors.Wrap(err, "models: failed to assign all query results to ProductGold slice")
	}

	if len(productGoldAfterSelectHooks) != 0 {
		for _, obj := range o {
			if err := obj.doAfterSelectHooks(ctx, exec); err != nil {
				return o, err
			}
		}
	}

	return o, nil
}

// Count returns the count of all ProductGold records in the query.
func (q productGoldQuery) Count(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	var count int64

	queries.SetSelect(q.Query, nil)
	queries.SetCount(q.Query)

	err := q.Query.QueryRowContext(ctx, exec).Scan(&count)
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to count product_gold rows")
	}

	return count, nil
}

// Exists checks if the row exists in the table.
func (q productGoldQuery) Exists(ctx context.Context, exec boil.ContextExecutor) (bool, error) {
	var count int64

	queries.SetSelect(q.Query, nil)
	queries.SetCount(q.Query)
	queries.SetLimit(q.Query, 1)

	err := q.Query.QueryRowContext(ctx, exec).Scan(&count)
	if err != nil {
		return false, errors.Wrap(err, "models: failed to check if product_gold exists")
	}

	return count > 0, nil
}

// CategoryGoal pointed to by the foreign key.
func (o *ProductGold) CategoryGoal(mods ...qm.QueryMod) categoryGoalQuery {
	queryMods := []qm.QueryMod{
		qm.Where("\"category_id\" = ?", o.CategoryGoalID),
	}

	queryMods = append(queryMods, mods...)

	return CategoryGoals(queryMods...)
}

// IDGoalOrderGoal pointed to by the foreign key.
func (o *ProductGold) IDGoalOrderGoal(mods ...qm.QueryMod) orderGoalQuery {
	queryMods := []qm.QueryMod{
		qm.Where("\"id\" = ?", o.IDGoal),
	}

	queryMods = append(queryMods, mods...)

	return OrderGoals(queryMods...)
}

// DetailProductDetailProductGolds retrieves all the detail_product_gold's DetailProductGolds with an executor via detail_product_id column.
func (o *ProductGold) DetailProductDetailProductGolds(mods ...qm.QueryMod) detailProductGoldQuery {
	var queryMods []qm.QueryMod
	if len(mods) != 0 {
		queryMods = append(queryMods, mods...)
	}

	queryMods = append(queryMods,
		qm.Where("\"detail_product_gold\".\"detail_product_id\"=?", o.ID),
	)

	return DetailProductGolds(queryMods...)
}

// LoadCategoryGoal allows an eager lookup of values, cached into the
// loaded structs of the objects. This is for an N-1 relationship.
func (productGoldL) LoadCategoryGoal(ctx context.Context, e boil.ContextExecutor, singular bool, maybeProductGold interface{}, mods queries.Applicator) error {
	var slice []*ProductGold
	var object *ProductGold

	if singular {
		var ok bool
		object, ok = maybeProductGold.(*ProductGold)
		if !ok {
			object = new(ProductGold)
			ok = queries.SetFromEmbeddedStruct(&object, &maybeProductGold)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", object, maybeProductGold))
			}
		}
	} else {
		s, ok := maybeProductGold.(*[]*ProductGold)
		if ok {
			slice = *s
		} else {
			ok = queries.SetFromEmbeddedStruct(&slice, maybeProductGold)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", slice, maybeProductGold))
			}
		}
	}

	args := make([]interface{}, 0, 1)
	if singular {
		if object.R == nil {
			object.R = &productGoldR{}
		}
		if !queries.IsNil(object.CategoryGoalID) {
			args = append(args, object.CategoryGoalID)
		}

	} else {
	Outer:
		for _, obj := range slice {
			if obj.R == nil {
				obj.R = &productGoldR{}
			}

			for _, a := range args {
				if queries.Equal(a, obj.CategoryGoalID) {
					continue Outer
				}
			}

			if !queries.IsNil(obj.CategoryGoalID) {
				args = append(args, obj.CategoryGoalID)
			}

		}
	}

	if len(args) == 0 {
		return nil
	}

	query := NewQuery(
		qm.From(`category_goal`),
		qm.WhereIn(`category_goal.category_id in ?`, args...),
	)
	if mods != nil {
		mods.Apply(query)
	}

	results, err := query.QueryContext(ctx, e)
	if err != nil {
		return errors.Wrap(err, "failed to eager load CategoryGoal")
	}

	var resultSlice []*CategoryGoal
	if err = queries.Bind(results, &resultSlice); err != nil {
		return errors.Wrap(err, "failed to bind eager loaded slice CategoryGoal")
	}

	if err = results.Close(); err != nil {
		return errors.Wrap(err, "failed to close results of eager load for category_goal")
	}
	if err = results.Err(); err != nil {
		return errors.Wrap(err, "error occurred during iteration of eager loaded relations for category_goal")
	}

	if len(categoryGoalAfterSelectHooks) != 0 {
		for _, obj := range resultSlice {
			if err := obj.doAfterSelectHooks(ctx, e); err != nil {
				return err
			}
		}
	}

	if len(resultSlice) == 0 {
		return nil
	}

	if singular {
		foreign := resultSlice[0]
		object.R.CategoryGoal = foreign
		if foreign.R == nil {
			foreign.R = &categoryGoalR{}
		}
		foreign.R.ProductGolds = append(foreign.R.ProductGolds, object)
		return nil
	}

	for _, local := range slice {
		for _, foreign := range resultSlice {
			if queries.Equal(local.CategoryGoalID, foreign.CategoryID) {
				local.R.CategoryGoal = foreign
				if foreign.R == nil {
					foreign.R = &categoryGoalR{}
				}
				foreign.R.ProductGolds = append(foreign.R.ProductGolds, local)
				break
			}
		}
	}

	return nil
}

// LoadIDGoalOrderGoal allows an eager lookup of values, cached into the
// loaded structs of the objects. This is for an N-1 relationship.
func (productGoldL) LoadIDGoalOrderGoal(ctx context.Context, e boil.ContextExecutor, singular bool, maybeProductGold interface{}, mods queries.Applicator) error {
	var slice []*ProductGold
	var object *ProductGold

	if singular {
		var ok bool
		object, ok = maybeProductGold.(*ProductGold)
		if !ok {
			object = new(ProductGold)
			ok = queries.SetFromEmbeddedStruct(&object, &maybeProductGold)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", object, maybeProductGold))
			}
		}
	} else {
		s, ok := maybeProductGold.(*[]*ProductGold)
		if ok {
			slice = *s
		} else {
			ok = queries.SetFromEmbeddedStruct(&slice, maybeProductGold)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", slice, maybeProductGold))
			}
		}
	}

	args := make([]interface{}, 0, 1)
	if singular {
		if object.R == nil {
			object.R = &productGoldR{}
		}
		if !queries.IsNil(object.IDGoal) {
			args = append(args, object.IDGoal)
		}

	} else {
	Outer:
		for _, obj := range slice {
			if obj.R == nil {
				obj.R = &productGoldR{}
			}

			for _, a := range args {
				if queries.Equal(a, obj.IDGoal) {
					continue Outer
				}
			}

			if !queries.IsNil(obj.IDGoal) {
				args = append(args, obj.IDGoal)
			}

		}
	}

	if len(args) == 0 {
		return nil
	}

	query := NewQuery(
		qm.From(`order_goal`),
		qm.WhereIn(`order_goal.id in ?`, args...),
	)
	if mods != nil {
		mods.Apply(query)
	}

	results, err := query.QueryContext(ctx, e)
	if err != nil {
		return errors.Wrap(err, "failed to eager load OrderGoal")
	}

	var resultSlice []*OrderGoal
	if err = queries.Bind(results, &resultSlice); err != nil {
		return errors.Wrap(err, "failed to bind eager loaded slice OrderGoal")
	}

	if err = results.Close(); err != nil {
		return errors.Wrap(err, "failed to close results of eager load for order_goal")
	}
	if err = results.Err(); err != nil {
		return errors.Wrap(err, "error occurred during iteration of eager loaded relations for order_goal")
	}

	if len(orderGoalAfterSelectHooks) != 0 {
		for _, obj := range resultSlice {
			if err := obj.doAfterSelectHooks(ctx, e); err != nil {
				return err
			}
		}
	}

	if len(resultSlice) == 0 {
		return nil
	}

	if singular {
		foreign := resultSlice[0]
		object.R.IDGoalOrderGoal = foreign
		if foreign.R == nil {
			foreign.R = &orderGoalR{}
		}
		foreign.R.IDGoalProductGolds = append(foreign.R.IDGoalProductGolds, object)
		return nil
	}

	for _, local := range slice {
		for _, foreign := range resultSlice {
			if queries.Equal(local.IDGoal, foreign.ID) {
				local.R.IDGoalOrderGoal = foreign
				if foreign.R == nil {
					foreign.R = &orderGoalR{}
				}
				foreign.R.IDGoalProductGolds = append(foreign.R.IDGoalProductGolds, local)
				break
			}
		}
	}

	return nil
}

// LoadDetailProductDetailProductGolds allows an eager lookup of values, cached into the
// loaded structs of the objects. This is for a 1-M or N-M relationship.
func (productGoldL) LoadDetailProductDetailProductGolds(ctx context.Context, e boil.ContextExecutor, singular bool, maybeProductGold interface{}, mods queries.Applicator) error {
	var slice []*ProductGold
	var object *ProductGold

	if singular {
		var ok bool
		object, ok = maybeProductGold.(*ProductGold)
		if !ok {
			object = new(ProductGold)
			ok = queries.SetFromEmbeddedStruct(&object, &maybeProductGold)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", object, maybeProductGold))
			}
		}
	} else {
		s, ok := maybeProductGold.(*[]*ProductGold)
		if ok {
			slice = *s
		} else {
			ok = queries.SetFromEmbeddedStruct(&slice, maybeProductGold)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", slice, maybeProductGold))
			}
		}
	}

	args := make([]interface{}, 0, 1)
	if singular {
		if object.R == nil {
			object.R = &productGoldR{}
		}
		args = append(args, object.ID)
	} else {
	Outer:
		for _, obj := range slice {
			if obj.R == nil {
				obj.R = &productGoldR{}
			}

			for _, a := range args {
				if queries.Equal(a, obj.ID) {
					continue Outer
				}
			}

			args = append(args, obj.ID)
		}
	}

	if len(args) == 0 {
		return nil
	}

	query := NewQuery(
		qm.From(`detail_product_gold`),
		qm.WhereIn(`detail_product_gold.detail_product_id in ?`, args...),
	)
	if mods != nil {
		mods.Apply(query)
	}

	results, err := query.QueryContext(ctx, e)
	if err != nil {
		return errors.Wrap(err, "failed to eager load detail_product_gold")
	}

	var resultSlice []*DetailProductGold
	if err = queries.Bind(results, &resultSlice); err != nil {
		return errors.Wrap(err, "failed to bind eager loaded slice detail_product_gold")
	}

	if err = results.Close(); err != nil {
		return errors.Wrap(err, "failed to close results in eager load on detail_product_gold")
	}
	if err = results.Err(); err != nil {
		return errors.Wrap(err, "error occurred during iteration of eager loaded relations for detail_product_gold")
	}

	if len(detailProductGoldAfterSelectHooks) != 0 {
		for _, obj := range resultSlice {
			if err := obj.doAfterSelectHooks(ctx, e); err != nil {
				return err
			}
		}
	}
	if singular {
		object.R.DetailProductDetailProductGolds = resultSlice
		for _, foreign := range resultSlice {
			if foreign.R == nil {
				foreign.R = &detailProductGoldR{}
			}
			foreign.R.DetailProduct = object
		}
		return nil
	}

	for _, foreign := range resultSlice {
		for _, local := range slice {
			if queries.Equal(local.ID, foreign.DetailProductID) {
				local.R.DetailProductDetailProductGolds = append(local.R.DetailProductDetailProductGolds, foreign)
				if foreign.R == nil {
					foreign.R = &detailProductGoldR{}
				}
				foreign.R.DetailProduct = local
				break
			}
		}
	}

	return nil
}

// SetCategoryGoal of the productGold to the related item.
// Sets o.R.CategoryGoal to related.
// Adds o to related.R.ProductGolds.
func (o *ProductGold) SetCategoryGoal(ctx context.Context, exec boil.ContextExecutor, insert bool, related *CategoryGoal) error {
	var err error
	if insert {
		if err = related.Insert(ctx, exec, boil.Infer()); err != nil {
			return errors.Wrap(err, "failed to insert into foreign table")
		}
	}

	updateQuery := fmt.Sprintf(
		"UPDATE \"product_gold\" SET %s WHERE %s",
		strmangle.SetParamNames("\"", "\"", 1, []string{"category_goal_id"}),
		strmangle.WhereClause("\"", "\"", 2, productGoldPrimaryKeyColumns),
	)
	values := []interface{}{related.CategoryID, o.ID}

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, updateQuery)
		fmt.Fprintln(writer, values)
	}
	if _, err = exec.ExecContext(ctx, updateQuery, values...); err != nil {
		return errors.Wrap(err, "failed to update local table")
	}

	queries.Assign(&o.CategoryGoalID, related.CategoryID)
	if o.R == nil {
		o.R = &productGoldR{
			CategoryGoal: related,
		}
	} else {
		o.R.CategoryGoal = related
	}

	if related.R == nil {
		related.R = &categoryGoalR{
			ProductGolds: ProductGoldSlice{o},
		}
	} else {
		related.R.ProductGolds = append(related.R.ProductGolds, o)
	}

	return nil
}

// RemoveCategoryGoal relationship.
// Sets o.R.CategoryGoal to nil.
// Removes o from all passed in related items' relationships struct.
func (o *ProductGold) RemoveCategoryGoal(ctx context.Context, exec boil.ContextExecutor, related *CategoryGoal) error {
	var err error

	queries.SetScanner(&o.CategoryGoalID, nil)
	if _, err = o.Update(ctx, exec, boil.Whitelist("category_goal_id")); err != nil {
		return errors.Wrap(err, "failed to update local table")
	}

	if o.R != nil {
		o.R.CategoryGoal = nil
	}
	if related == nil || related.R == nil {
		return nil
	}

	for i, ri := range related.R.ProductGolds {
		if queries.Equal(o.CategoryGoalID, ri.CategoryGoalID) {
			continue
		}

		ln := len(related.R.ProductGolds)
		if ln > 1 && i < ln-1 {
			related.R.ProductGolds[i] = related.R.ProductGolds[ln-1]
		}
		related.R.ProductGolds = related.R.ProductGolds[:ln-1]
		break
	}
	return nil
}

// SetIDGoalOrderGoal of the productGold to the related item.
// Sets o.R.IDGoalOrderGoal to related.
// Adds o to related.R.IDGoalProductGolds.
func (o *ProductGold) SetIDGoalOrderGoal(ctx context.Context, exec boil.ContextExecutor, insert bool, related *OrderGoal) error {
	var err error
	if insert {
		if err = related.Insert(ctx, exec, boil.Infer()); err != nil {
			return errors.Wrap(err, "failed to insert into foreign table")
		}
	}

	updateQuery := fmt.Sprintf(
		"UPDATE \"product_gold\" SET %s WHERE %s",
		strmangle.SetParamNames("\"", "\"", 1, []string{"id_goal"}),
		strmangle.WhereClause("\"", "\"", 2, productGoldPrimaryKeyColumns),
	)
	values := []interface{}{related.ID, o.ID}

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, updateQuery)
		fmt.Fprintln(writer, values)
	}
	if _, err = exec.ExecContext(ctx, updateQuery, values...); err != nil {
		return errors.Wrap(err, "failed to update local table")
	}

	queries.Assign(&o.IDGoal, related.ID)
	if o.R == nil {
		o.R = &productGoldR{
			IDGoalOrderGoal: related,
		}
	} else {
		o.R.IDGoalOrderGoal = related
	}

	if related.R == nil {
		related.R = &orderGoalR{
			IDGoalProductGolds: ProductGoldSlice{o},
		}
	} else {
		related.R.IDGoalProductGolds = append(related.R.IDGoalProductGolds, o)
	}

	return nil
}

// RemoveIDGoalOrderGoal relationship.
// Sets o.R.IDGoalOrderGoal to nil.
// Removes o from all passed in related items' relationships struct.
func (o *ProductGold) RemoveIDGoalOrderGoal(ctx context.Context, exec boil.ContextExecutor, related *OrderGoal) error {
	var err error

	queries.SetScanner(&o.IDGoal, nil)
	if _, err = o.Update(ctx, exec, boil.Whitelist("id_goal")); err != nil {
		return errors.Wrap(err, "failed to update local table")
	}

	if o.R != nil {
		o.R.IDGoalOrderGoal = nil
	}
	if related == nil || related.R == nil {
		return nil
	}

	for i, ri := range related.R.IDGoalProductGolds {
		if queries.Equal(o.IDGoal, ri.IDGoal) {
			continue
		}

		ln := len(related.R.IDGoalProductGolds)
		if ln > 1 && i < ln-1 {
			related.R.IDGoalProductGolds[i] = related.R.IDGoalProductGolds[ln-1]
		}
		related.R.IDGoalProductGolds = related.R.IDGoalProductGolds[:ln-1]
		break
	}
	return nil
}

// AddDetailProductDetailProductGolds adds the given related objects to the existing relationships
// of the product_gold, optionally inserting them as new records.
// Appends related to o.R.DetailProductDetailProductGolds.
// Sets related.R.DetailProduct appropriately.
func (o *ProductGold) AddDetailProductDetailProductGolds(ctx context.Context, exec boil.ContextExecutor, insert bool, related ...*DetailProductGold) error {
	var err error
	for _, rel := range related {
		if insert {
			queries.Assign(&rel.DetailProductID, o.ID)
			if err = rel.Insert(ctx, exec, boil.Infer()); err != nil {
				return errors.Wrap(err, "failed to insert into foreign table")
			}
		} else {
			updateQuery := fmt.Sprintf(
				"UPDATE \"detail_product_gold\" SET %s WHERE %s",
				strmangle.SetParamNames("\"", "\"", 1, []string{"detail_product_id"}),
				strmangle.WhereClause("\"", "\"", 2, detailProductGoldPrimaryKeyColumns),
			)
			values := []interface{}{o.ID, rel.ID}

			if boil.IsDebug(ctx) {
				writer := boil.DebugWriterFrom(ctx)
				fmt.Fprintln(writer, updateQuery)
				fmt.Fprintln(writer, values)
			}
			if _, err = exec.ExecContext(ctx, updateQuery, values...); err != nil {
				return errors.Wrap(err, "failed to update foreign table")
			}

			queries.Assign(&rel.DetailProductID, o.ID)
		}
	}

	if o.R == nil {
		o.R = &productGoldR{
			DetailProductDetailProductGolds: related,
		}
	} else {
		o.R.DetailProductDetailProductGolds = append(o.R.DetailProductDetailProductGolds, related...)
	}

	for _, rel := range related {
		if rel.R == nil {
			rel.R = &detailProductGoldR{
				DetailProduct: o,
			}
		} else {
			rel.R.DetailProduct = o
		}
	}
	return nil
}

// SetDetailProductDetailProductGolds removes all previously related items of the
// product_gold replacing them completely with the passed
// in related items, optionally inserting them as new records.
// Sets o.R.DetailProduct's DetailProductDetailProductGolds accordingly.
// Replaces o.R.DetailProductDetailProductGolds with related.
// Sets related.R.DetailProduct's DetailProductDetailProductGolds accordingly.
func (o *ProductGold) SetDetailProductDetailProductGolds(ctx context.Context, exec boil.ContextExecutor, insert bool, related ...*DetailProductGold) error {
	query := "update \"detail_product_gold\" set \"detail_product_id\" = null where \"detail_product_id\" = $1"
	values := []interface{}{o.ID}
	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, query)
		fmt.Fprintln(writer, values)
	}
	_, err := exec.ExecContext(ctx, query, values...)
	if err != nil {
		return errors.Wrap(err, "failed to remove relationships before set")
	}

	if o.R != nil {
		for _, rel := range o.R.DetailProductDetailProductGolds {
			queries.SetScanner(&rel.DetailProductID, nil)
			if rel.R == nil {
				continue
			}

			rel.R.DetailProduct = nil
		}
		o.R.DetailProductDetailProductGolds = nil
	}

	return o.AddDetailProductDetailProductGolds(ctx, exec, insert, related...)
}

// RemoveDetailProductDetailProductGolds relationships from objects passed in.
// Removes related items from R.DetailProductDetailProductGolds (uses pointer comparison, removal does not keep order)
// Sets related.R.DetailProduct.
func (o *ProductGold) RemoveDetailProductDetailProductGolds(ctx context.Context, exec boil.ContextExecutor, related ...*DetailProductGold) error {
	if len(related) == 0 {
		return nil
	}

	var err error
	for _, rel := range related {
		queries.SetScanner(&rel.DetailProductID, nil)
		if rel.R != nil {
			rel.R.DetailProduct = nil
		}
		if _, err = rel.Update(ctx, exec, boil.Whitelist("detail_product_id")); err != nil {
			return err
		}
	}
	if o.R == nil {
		return nil
	}

	for _, rel := range related {
		for i, ri := range o.R.DetailProductDetailProductGolds {
			if rel != ri {
				continue
			}

			ln := len(o.R.DetailProductDetailProductGolds)
			if ln > 1 && i < ln-1 {
				o.R.DetailProductDetailProductGolds[i] = o.R.DetailProductDetailProductGolds[ln-1]
			}
			o.R.DetailProductDetailProductGolds = o.R.DetailProductDetailProductGolds[:ln-1]
			break
		}
	}

	return nil
}

// ProductGolds retrieves all the records using an executor.
func ProductGolds(mods ...qm.QueryMod) productGoldQuery {
	mods = append(mods, qm.From("\"product_gold\""))
	q := NewQuery(mods...)
	if len(queries.GetSelect(q)) == 0 {
		queries.SetSelect(q, []string{"\"product_gold\".*"})
	}

	return productGoldQuery{q}
}

// FindProductGold retrieves a single record by ID with an executor.
// If selectCols is empty Find will return all columns.
func FindProductGold(ctx context.Context, exec boil.ContextExecutor, iD int64, selectCols ...string) (*ProductGold, error) {
	productGoldObj := &ProductGold{}

	sel := "*"
	if len(selectCols) > 0 {
		sel = strings.Join(strmangle.IdentQuoteSlice(dialect.LQ, dialect.RQ, selectCols), ",")
	}
	query := fmt.Sprintf(
		"select %s from \"product_gold\" where \"id\"=$1", sel,
	)

	q := queries.Raw(query, iD)

	err := q.Bind(ctx, exec, productGoldObj)
	if err != nil {
		if errors.Is(err, sql.ErrNoRows) {
			return nil, sql.ErrNoRows
		}
		return nil, errors.Wrap(err, "models: unable to select from product_gold")
	}

	if err = productGoldObj.doAfterSelectHooks(ctx, exec); err != nil {
		return productGoldObj, err
	}

	return productGoldObj, nil
}

// Insert a single record using an executor.
// See boil.Columns.InsertColumnSet documentation to understand column list inference for inserts.
func (o *ProductGold) Insert(ctx context.Context, exec boil.ContextExecutor, columns boil.Columns) error {
	if o == nil {
		return errors.New("models: no product_gold provided for insertion")
	}

	var err error
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		if o.CreatedAt.IsZero() {
			o.CreatedAt = currTime
		}
		if o.UpdatedAt.IsZero() {
			o.UpdatedAt = currTime
		}
	}

	if err := o.doBeforeInsertHooks(ctx, exec); err != nil {
		return err
	}

	nzDefaults := queries.NonZeroDefaultSet(productGoldColumnsWithDefault, o)

	key := makeCacheKey(columns, nzDefaults)
	productGoldInsertCacheMut.RLock()
	cache, cached := productGoldInsertCache[key]
	productGoldInsertCacheMut.RUnlock()

	if !cached {
		wl, returnColumns := columns.InsertColumnSet(
			productGoldAllColumns,
			productGoldColumnsWithDefault,
			productGoldColumnsWithoutDefault,
			nzDefaults,
		)

		cache.valueMapping, err = queries.BindMapping(productGoldType, productGoldMapping, wl)
		if err != nil {
			return err
		}
		cache.retMapping, err = queries.BindMapping(productGoldType, productGoldMapping, returnColumns)
		if err != nil {
			return err
		}
		if len(wl) != 0 {
			cache.query = fmt.Sprintf("INSERT INTO \"product_gold\" (\"%s\") %%sVALUES (%s)%%s", strings.Join(wl, "\",\""), strmangle.Placeholders(dialect.UseIndexPlaceholders, len(wl), 1, 1))
		} else {
			cache.query = "INSERT INTO \"product_gold\" %sDEFAULT VALUES%s"
		}

		var queryOutput, queryReturning string

		if len(cache.retMapping) != 0 {
			queryReturning = fmt.Sprintf(" RETURNING \"%s\"", strings.Join(returnColumns, "\",\""))
		}

		cache.query = fmt.Sprintf(cache.query, queryOutput, queryReturning)
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	vals := queries.ValuesFromMapping(value, cache.valueMapping)

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, vals)
	}

	if len(cache.retMapping) != 0 {
		err = exec.QueryRowContext(ctx, cache.query, vals...).Scan(queries.PtrsFromMapping(value, cache.retMapping)...)
	} else {
		_, err = exec.ExecContext(ctx, cache.query, vals...)
	}

	if err != nil {
		return errors.Wrap(err, "models: unable to insert into product_gold")
	}

	if !cached {
		productGoldInsertCacheMut.Lock()
		productGoldInsertCache[key] = cache
		productGoldInsertCacheMut.Unlock()
	}

	return o.doAfterInsertHooks(ctx, exec)
}

// Update uses an executor to update the ProductGold.
// See boil.Columns.UpdateColumnSet documentation to understand column list inference for updates.
// Update does not automatically update the record in case of default values. Use .Reload() to refresh the records.
func (o *ProductGold) Update(ctx context.Context, exec boil.ContextExecutor, columns boil.Columns) (int64, error) {
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		o.UpdatedAt = currTime
	}

	var err error
	if err = o.doBeforeUpdateHooks(ctx, exec); err != nil {
		return 0, err
	}
	key := makeCacheKey(columns, nil)
	productGoldUpdateCacheMut.RLock()
	cache, cached := productGoldUpdateCache[key]
	productGoldUpdateCacheMut.RUnlock()

	if !cached {
		wl := columns.UpdateColumnSet(
			productGoldAllColumns,
			productGoldPrimaryKeyColumns,
		)

		if !columns.IsWhitelist() {
			wl = strmangle.SetComplement(wl, []string{"created_at"})
		}
		if len(wl) == 0 {
			return 0, errors.New("models: unable to update product_gold, could not build whitelist")
		}

		cache.query = fmt.Sprintf("UPDATE \"product_gold\" SET %s WHERE %s",
			strmangle.SetParamNames("\"", "\"", 1, wl),
			strmangle.WhereClause("\"", "\"", len(wl)+1, productGoldPrimaryKeyColumns),
		)
		cache.valueMapping, err = queries.BindMapping(productGoldType, productGoldMapping, append(wl, productGoldPrimaryKeyColumns...))
		if err != nil {
			return 0, err
		}
	}

	values := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(o)), cache.valueMapping)

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, values)
	}
	var result sql.Result
	result, err = exec.ExecContext(ctx, cache.query, values...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update product_gold row")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by update for product_gold")
	}

	if !cached {
		productGoldUpdateCacheMut.Lock()
		productGoldUpdateCache[key] = cache
		productGoldUpdateCacheMut.Unlock()
	}

	return rowsAff, o.doAfterUpdateHooks(ctx, exec)
}

// UpdateAll updates all rows with the specified column values.
func (q productGoldQuery) UpdateAll(ctx context.Context, exec boil.ContextExecutor, cols M) (int64, error) {
	queries.SetUpdate(q.Query, cols)

	result, err := q.Query.ExecContext(ctx, exec)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update all for product_gold")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to retrieve rows affected for product_gold")
	}

	return rowsAff, nil
}

// UpdateAll updates all rows with the specified column values, using an executor.
func (o ProductGoldSlice) UpdateAll(ctx context.Context, exec boil.ContextExecutor, cols M) (int64, error) {
	ln := int64(len(o))
	if ln == 0 {
		return 0, nil
	}

	if len(cols) == 0 {
		return 0, errors.New("models: update all requires at least one column argument")
	}

	colNames := make([]string, len(cols))
	args := make([]interface{}, len(cols))

	i := 0
	for name, value := range cols {
		colNames[i] = name
		args[i] = value
		i++
	}

	// Append all of the primary key values for each column
	for _, obj := range o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), productGoldPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := fmt.Sprintf("UPDATE \"product_gold\" SET %s WHERE %s",
		strmangle.SetParamNames("\"", "\"", 1, colNames),
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), len(colNames)+1, productGoldPrimaryKeyColumns, len(o)))

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args...)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update all in productGold slice")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to retrieve rows affected all in update all productGold")
	}
	return rowsAff, nil
}

// Upsert attempts an insert using an executor, and does an update or ignore on conflict.
// See boil.Columns documentation for how to properly use updateColumns and insertColumns.
func (o *ProductGold) Upsert(ctx context.Context, exec boil.ContextExecutor, updateOnConflict bool, conflictColumns []string, updateColumns, insertColumns boil.Columns) error {
	if o == nil {
		return errors.New("models: no product_gold provided for upsert")
	}
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		if o.CreatedAt.IsZero() {
			o.CreatedAt = currTime
		}
		o.UpdatedAt = currTime
	}

	if err := o.doBeforeUpsertHooks(ctx, exec); err != nil {
		return err
	}

	nzDefaults := queries.NonZeroDefaultSet(productGoldColumnsWithDefault, o)

	// Build cache key in-line uglily - mysql vs psql problems
	buf := strmangle.GetBuffer()
	if updateOnConflict {
		buf.WriteByte('t')
	} else {
		buf.WriteByte('f')
	}
	buf.WriteByte('.')
	for _, c := range conflictColumns {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	buf.WriteString(strconv.Itoa(updateColumns.Kind))
	for _, c := range updateColumns.Cols {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	buf.WriteString(strconv.Itoa(insertColumns.Kind))
	for _, c := range insertColumns.Cols {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	for _, c := range nzDefaults {
		buf.WriteString(c)
	}
	key := buf.String()
	strmangle.PutBuffer(buf)

	productGoldUpsertCacheMut.RLock()
	cache, cached := productGoldUpsertCache[key]
	productGoldUpsertCacheMut.RUnlock()

	var err error

	if !cached {
		insert, ret := insertColumns.InsertColumnSet(
			productGoldAllColumns,
			productGoldColumnsWithDefault,
			productGoldColumnsWithoutDefault,
			nzDefaults,
		)

		update := updateColumns.UpdateColumnSet(
			productGoldAllColumns,
			productGoldPrimaryKeyColumns,
		)

		if updateOnConflict && len(update) == 0 {
			return errors.New("models: unable to upsert product_gold, could not build update column list")
		}

		conflict := conflictColumns
		if len(conflict) == 0 {
			conflict = make([]string, len(productGoldPrimaryKeyColumns))
			copy(conflict, productGoldPrimaryKeyColumns)
		}
		cache.query = buildUpsertQueryPostgres(dialect, "\"product_gold\"", updateOnConflict, ret, update, conflict, insert)

		cache.valueMapping, err = queries.BindMapping(productGoldType, productGoldMapping, insert)
		if err != nil {
			return err
		}
		if len(ret) != 0 {
			cache.retMapping, err = queries.BindMapping(productGoldType, productGoldMapping, ret)
			if err != nil {
				return err
			}
		}
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	vals := queries.ValuesFromMapping(value, cache.valueMapping)
	var returns []interface{}
	if len(cache.retMapping) != 0 {
		returns = queries.PtrsFromMapping(value, cache.retMapping)
	}

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, vals)
	}
	if len(cache.retMapping) != 0 {
		err = exec.QueryRowContext(ctx, cache.query, vals...).Scan(returns...)
		if errors.Is(err, sql.ErrNoRows) {
			err = nil // Postgres doesn't return anything when there's no update
		}
	} else {
		_, err = exec.ExecContext(ctx, cache.query, vals...)
	}
	if err != nil {
		return errors.Wrap(err, "models: unable to upsert product_gold")
	}

	if !cached {
		productGoldUpsertCacheMut.Lock()
		productGoldUpsertCache[key] = cache
		productGoldUpsertCacheMut.Unlock()
	}

	return o.doAfterUpsertHooks(ctx, exec)
}

// Delete deletes a single ProductGold record with an executor.
// Delete will match against the primary key column to find the record to delete.
func (o *ProductGold) Delete(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if o == nil {
		return 0, errors.New("models: no ProductGold provided for delete")
	}

	if err := o.doBeforeDeleteHooks(ctx, exec); err != nil {
		return 0, err
	}

	args := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(o)), productGoldPrimaryKeyMapping)
	sql := "DELETE FROM \"product_gold\" WHERE \"id\"=$1"

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args...)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete from product_gold")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by delete for product_gold")
	}

	if err := o.doAfterDeleteHooks(ctx, exec); err != nil {
		return 0, err
	}

	return rowsAff, nil
}

// DeleteAll deletes all matching rows.
func (q productGoldQuery) DeleteAll(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if q.Query == nil {
		return 0, errors.New("models: no productGoldQuery provided for delete all")
	}

	queries.SetDelete(q.Query)

	result, err := q.Query.ExecContext(ctx, exec)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete all from product_gold")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by deleteall for product_gold")
	}

	return rowsAff, nil
}

// DeleteAll deletes all rows in the slice, using an executor.
func (o ProductGoldSlice) DeleteAll(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if len(o) == 0 {
		return 0, nil
	}

	if len(productGoldBeforeDeleteHooks) != 0 {
		for _, obj := range o {
			if err := obj.doBeforeDeleteHooks(ctx, exec); err != nil {
				return 0, err
			}
		}
	}

	var args []interface{}
	for _, obj := range o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), productGoldPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := "DELETE FROM \"product_gold\" WHERE " +
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), 1, productGoldPrimaryKeyColumns, len(o))

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete all from productGold slice")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by deleteall for product_gold")
	}

	if len(productGoldAfterDeleteHooks) != 0 {
		for _, obj := range o {
			if err := obj.doAfterDeleteHooks(ctx, exec); err != nil {
				return 0, err
			}
		}
	}

	return rowsAff, nil
}

// Reload refetches the object from the database
// using the primary keys with an executor.
func (o *ProductGold) Reload(ctx context.Context, exec boil.ContextExecutor) error {
	ret, err := FindProductGold(ctx, exec, o.ID)
	if err != nil {
		return err
	}

	*o = *ret
	return nil
}

// ReloadAll refetches every row with matching primary key column values
// and overwrites the original object slice with the newly updated slice.
func (o *ProductGoldSlice) ReloadAll(ctx context.Context, exec boil.ContextExecutor) error {
	if o == nil || len(*o) == 0 {
		return nil
	}

	slice := ProductGoldSlice{}
	var args []interface{}
	for _, obj := range *o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), productGoldPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := "SELECT \"product_gold\".* FROM \"product_gold\" WHERE " +
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), 1, productGoldPrimaryKeyColumns, len(*o))

	q := queries.Raw(sql, args...)

	err := q.Bind(ctx, exec, &slice)
	if err != nil {
		return errors.Wrap(err, "models: unable to reload all in ProductGoldSlice")
	}

	*o = slice

	return nil
}

// ProductGoldExists checks if the ProductGold row exists.
func ProductGoldExists(ctx context.Context, exec boil.ContextExecutor, iD int64) (bool, error) {
	var exists bool
	sql := "select exists(select 1 from \"product_gold\" where \"id\"=$1 limit 1)"

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, iD)
	}
	row := exec.QueryRowContext(ctx, sql, iD)

	err := row.Scan(&exists)
	if err != nil {
		return false, errors.Wrap(err, "models: unable to check if product_gold exists")
	}

	return exists, nil
}

// Exists checks if the ProductGold row exists.
func (o *ProductGold) Exists(ctx context.Context, exec boil.ContextExecutor) (bool, error) {
	return ProductGoldExists(ctx, exec, o.ID)
}
